/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#include "Servo.h"
#include "sim_helper.h"
#include "esp32-hal-ledc.h"
//
#define ESP32_SERVO_PWM_RES 12
#define ESP32_SERVO_PWM_MAX_VAL 4095

Servo::Servo()
{
    m_pin = m_min = m_max = 0;
    m_pulse_factor = 0;
}

Servo::~Servo()
{
}

void Servo::attach(int pin, int min, int max, int period)
{
    m_pin = pin;
    m_min = min;
    m_max = max;
    m_pulse_factor = (float)ESP32_SERVO_PWM_MAX_VAL/(float)period;
    //
    int channel = analogWriteChannel(m_pin);
    //analogResetConfiguration(pin);
    analogWriteConfigure(m_pin, channel, ESP32_SERVO_PWM_RES, 1000000.0f/(float)period);
    //ledcSetup(channel+1, (int)(1000000.0f/(float)period), ESP32_SERVO_PWM_RES);
    //ledcAttachPin(m_pin, channel+1);
}

void Servo::write(float angle)
{
    unsigned int period = (unsigned int)MapRange(angle, m_max, m_min, 180, 0);
    writeMicroseconds(period);
}

void Servo::writeMicroseconds(unsigned int micro_sec)
{
    //assumed limits are already checked
    //int channel = analogWriteChannel(m_pin);
    //ledcWrite(channel+1, (int32_t)(micro_sec*m_pulse_factor));
    analogWrite(m_pin, (unsigned int)(micro_sec*m_pulse_factor));
}
