/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#include "Arduino.h"
#include "esp_task_wdt.h"
#include "simcode_sketch.h"
#include "RootSignalClass.h"
#include "simcode.h"
#include "esp32_thread.h"

#if defined (_BUILD_ARCH_OS) && !defined(_BUILD_HAS_SIM_PNL)
static unsigned char g_task_count = 0;
void* SimCreateThread(int (*thread_function)(void*), CTHREAD_PARAM *thread_param, int thread_priority, int core_idx)
{
    TaskHandle_t taskHandle;
    char name[128];
    snprintf(name, 127, "SimTask%d",g_task_count);
    g_task_count += 1;
    void (*thread_func)(void*) = (void(*)(void*))thread_function;
    if(core_idx < 0) core_idx = 0;
    //else core_idx = 1;//always run on APP CPU
    unsigned char th_prior = configMAX_PRIORITIES-3;
    //if(thread_priority)th_prior = configMAX_PRIORITIES>>2;//if enabled, lowest task is always blocked
    if(th_prior < 1)th_prior = 1;
    //
    xTaskCreateUniversal(thread_func, name, 8192, thread_param, th_prior, &taskHandle, core_idx);
    //xTaskCreate(thread_func, name, 8192, thread_param, th_prior, &taskHandle);//this is creating thread on PRO CPU
    //
    esp_task_wdt_delete(taskHandle);
    return (void*)&taskHandle;
}

void Sim_PreSimFunc()
{

}

void Sim_TimeStepStartFunc()
{

}

void Sim_TimeStepEndFunc()
{

}

void Sim_PlotStepFunc()
{

}

void Sim_PostSimFunc()
{

}
#endif//(_BUILD_ARCH_OS) && !defined(_BUILD_HAS_SIM_PNL)

#if (RUN_FUNC_COUNT > 1)
void loop1()
{
    if(g_run_para.user_paused || g_run_para.thread_sync[1] == 0)
        return;
#ifdef _SIM_REAL_TIME
    g_run_para.thread_sync[1] = 0;//dont shift this down
#endif
#if (SIM_TARGETHW_RUN_DELAY > 0)
    delay(SIM_TARGETHW_RUN_DELAY);
#endif
    //execute all functions above this core index
    for(int i=1; i<RUN_FUNC_COUNT; ++i)
        (g_rootsig_obj.*g_rootsig_obj.PtrToRun[i])(&g_run_para);
}
#endif//RUN_FUNC_COUNT
