/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef SIM_THW_IPC_H
#define SIM_THW_IPC_H

#include <stdio.h>
#include "sim_common_definitions.h"

////////////////////////////////////////////////////////shared memory///////////////////////////////////////////////////////
#ifndef SIM_STATIC_SHM_OFFSET
#define SIM_STATIC_SHM_OFFSET 0
#endif
#ifndef SIM_STATIC_SHM_SIZE
#define SIM_STATIC_SHM_SIZE 0
#endif
#define STATIC_SHM_SECS 32 //depends on platform
class StaticSharedMem
{
public:
    StaticSharedMem();
    ~StaticSharedMem();
    _BOOLEAN pre_allocate(_BYTE index, _UINT32 size, _BIT write_only);
    _BOOLEAN allocate(_BYTE index, _BIT write_only);
    _UINT32 write(_BYTE index, const _BYTE *data, _UINT32 size);
    _UINT32 read(_BYTE index, _BYTE *buff, _UINT32 read_size);
protected:
private:
};
extern StaticSharedMem StaticShm;
////////////////////////////////////////////////////////////HSEM////////////////////////////////////////////////////////////
#define HSEM_COUNT 16
class HwdSemaphore
{
public:
    HwdSemaphore();
    ~HwdSemaphore();
    _BOOLEAN lock(const _BYTE id, _BOOLEAN blocking);
    void unlock(const _BYTE id);
private:
};
extern HwdSemaphore HwdSem;

#endif//SIM_THW_IPC_H
