#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "esp_task_wdt.h"
#include "Arduino.h"
#include "sim_common_definitions.h"
#include "RootSignalClass.h"

//#if CONFIG_AUTOSTART_ARDUINO

#define WDT_TIMEOUT 3600

void loopTask0(void *pvParameters)
{
    esp_task_wdt_init(WDT_TIMEOUT, false);
    //volatile _INT32 count = 0;
    //_INT64 prev = millis();
    while(1)
    {
        loop();
//        if(count++ > 1000)
//        {
//            count = 0;
//            _INT64 cur = millis();
//            //if(cur - prev > (WDT_TIMEOUT-1)*1000)
//            {
//                prev = cur;
//                //esp_task_wdt_reset();
//            }
//        }
    }
}

void loopTask1(void *pvParameters)
{
    esp_task_wdt_init(WDT_TIMEOUT, false);
    //volatile _INT32 count = 0;
    //_INT64 prev = millis();
    while(1)
    {
        loop1();
//        if(count++ > 1000)
//        {
//            count = 0;
//            _INT64 cur = millis();
//            //if(cur - prev > (WDT_TIMEOUT-1)*1000)
//            {
//                prev = cur;
//                //esp_task_wdt_reset();
//            }
//        }
    }
}

extern "C" void app_main()
{
    TaskHandle_t taskHandle = 0;
    initArduino();
#ifdef SIM_DEBUG_REMOTE
    Serial.begin(115200);
    delay(5000);//wait for user to connect to serial
#endif
    setup();
    //start core-2 only after setup() is called
    xTaskCreateUniversal(loopTask0, "loopTask0", 8192, NULL, 1, &taskHandle, 1);
#if (RUN_FUNC_COUNT > 1)
    xTaskCreateUniversal(loopTask1, "loopTask1", 8192, NULL, 1, &taskHandle, 2);
#endif//N_LOGICAL_CPU_CORES
}

//#endif
